export declare const LOCAL_PROVIDER_NAME = "local";
export declare const DEFAULTS: {
    weights: string[];
    styles: ["normal", "italic"];
    subsets: [string, string, string, string, string, string, string];
    fallbacks: [string];
    optimizedFallbacks: true;
};
export declare const VIRTUAL_MODULE_ID = "virtual:astro:assets/fonts/internal";
export declare const RESOLVED_VIRTUAL_MODULE_ID: string;
export declare const URL_PREFIX = "/_astro/fonts/";
export declare const CACHE_DIR = "./fonts/";
export declare const FONT_TYPES: readonly ["woff2", "woff", "otf", "ttf", "eot"];
export declare const FONT_FORMAT_MAP: Record<(typeof FONT_TYPES)[number], string>;
export declare const SYSTEM_METRICS: {
    'Times New Roman': {
        ascent: number;
        descent: number;
        lineGap: number;
        unitsPerEm: number;
        xWidthAvg: number;
    };
    Arial: {
        ascent: number;
        descent: number;
        lineGap: number;
        unitsPerEm: number;
        xWidthAvg: number;
    };
    'Courier New': {
        ascent: number;
        descent: number;
        lineGap: number;
        unitsPerEm: number;
        xWidthAvg: number;
    };
    BlinkMacSystemFont: {
        ascent: number;
        descent: number;
        lineGap: number;
        unitsPerEm: number;
        xWidthAvg: number;
    };
    'Segoe UI': {
        ascent: number;
        descent: number;
        lineGap: number;
        unitsPerEm: number;
        xWidthAvg: number;
    };
    Roboto: {
        ascent: number;
        descent: number;
        lineGap: number;
        unitsPerEm: number;
        xWidthAvg: number;
    };
    'Helvetica Neue': {
        ascent: number;
        descent: number;
        lineGap: number;
        unitsPerEm: number;
        xWidthAvg: number;
    };
};
export declare const DEFAULT_FALLBACKS: {
    readonly serif: ["Times New Roman"];
    readonly 'sans-serif': ["Arial"];
    readonly monospace: ["Courier New"];
    readonly cursive: [];
    readonly fantasy: [];
    readonly 'system-ui': ["BlinkMacSystemFont", "Segoe UI", "Roboto", "Helvetica Neue", "Arial"];
    readonly 'ui-serif': ["Times New Roman"];
    readonly 'ui-sans-serif': ["Arial"];
    readonly 'ui-monospace': ["Courier New"];
    readonly 'ui-rounded': [];
    readonly emoji: [];
    readonly math: [];
    readonly fangsong: [];
};
export declare const FONTS_TYPES_FILE = "fonts.d.ts";
