// Set any item to undefined to remove it from the site or to use the default value

export const GLOBAL = {
  // Site metadata
  username: "Justin Deal",
  rootUrl: "https://justin.deal",
  shortDescription: "My personal slice of the internet",
  longDescription: "Zaggonaut is a retro-inspired theme for Astro, built using TypeScript, TailwindCSS, and Astro.",
  
  // Social media links
  githubProfile: "https://github.com/RATIU5/zaggonaut",
  twitterProfile: "https://twitter.com/",
  linkedinProfile: "https://www.linkedin.com/",
  
  // Common text names used throughout the site
  articlesName: "Articles",
  projectsName: "Projects",
  viewAll: "View All",
  
  // Common descriptions used throughout the site
  noArticles: "No featured articles yet.",
  noProjects: "No featured projects yet.",

  // Blog metadata
  blogTitle: "My Thoughts & Takes",
  blogShortDescription: "Practical wisdom, unfiltered thoughts, and hot takes.",
  blogLongDescription: "Web development, tech trends, and the occasional programming mishap.",

  // Project metadata
  projectTitle: "Projects and Code",
  projectShortDescription: "A list of my web development projects and developer tools.",
  projectLongDescription: "All of my projects, including both frontend and full-stack applications.",

  // Profile image
  profileImage: "pixel_avatar.png",

  // Menu items
  menu: {
    home: "/",
    blog: "/blog",
    projects: "/projects",
    homelab: "/homelab",
    // about: "/about",
    // code: "https://code.justin.deal",
    // videos: "https://www.youtube.com/@justin_deal",
    // homelab: "https://homelab.justin.deal",
    // contact: "/contact",
  }
};
